searchNodes=[{"ref":"BSV.html","title":"BSV","type":"module","doc":"BSV-ex. Elixir Bitcoin SV library. The intent of this library is to provide a full-featured BSV library that is broadly comparable in scope to Money Button&#39;s BSV Javascript library. Currently this library offers the following: General crypto functions - wide range of hashing, ECDSA and RSA encryption and signature functions. Bitcoin specific crypto - Electrum-compatible message encryption and signatures. Bitcoin key pair generation and related functions. BIP-39 mnemonic phrase generation and deterministic keys. Raw transaction parsing, manipulation and serialization. What is NOT in this library: P2P - this is not a full node implementation. Installation As this package uses libsecp256k1 NIF bindings, please ensure you have libtool, automake and autogen installed in order for the package to compile. The package can be installed by adding bsv to your list of dependencies in mix.exs: def deps do [ {:bsv, &quot;~&gt; 0.1.0&quot;} ] end Usage Many examples are demonstrated throught the documentation, but see the following for some quick-start examples: Key pairs and addresses For more examples refer to BSV.KeyPair and BSV.Address. iex&gt; keys = BSV.KeyPair.generate %BSV.KeyPair{ network: :main, private_key: &lt;&lt;1, 249, 98, 144, 230, 172, 5, 56, 197, 143, 133, 240, 144, 223, 25, 32, 55, 42, 159, 26, 128, 66, 149, 49, 235, 179, 116, 11, 209, 235, 240, 163&gt;&gt;, public_key: &lt;&lt;3, 173, 251, 14, 108, 217, 224, 80, 133, 244, 200, 33, 191, 137, 80, 62, 141, 133, 166, 201, 224, 141, 101, 152, 144, 92, 237, 54, 220, 131, 58, 26, 4&gt;&gt; } iex&gt; address = BSV.Address.to_string(keys) &quot;1MzYtHPymTjgxx9npR6Pu9ZCUhtU9hHYTL&quot; Mnemonic phrase and deterministic keys For further details and examples refer to BSV.Mnemonic, BSV.Extended.PrivateKey, BSV.Extended.PublicKey and BSV.Extended.Children. iex&gt; mnemonic = BSV.Mnemonic.generate &quot;various attitude grain market food wheat arena disagree soccer dust wrestle auction fiber wrestle sort wonder vital gym ill word amazing sniff have biology&quot; iex&gt; master = BSV.Mnemonic.to_seed(mnemonic) ...&gt; |&gt; BSV.Extended.PrivateKey.from_seed %BSV.Extended.PrivateKey{ chain_code: &lt;&lt;164, 12, 192, 154, 59, 209, 85, 172, 76, 7, 42, 138, 247, 125, 161, 30, 135, 25, 124, 160, 170, 234, 126, 162, 228, 146, 135, 232, 67, 181, 219, 91&gt;&gt;, child_number: 0, depth: 0, fingerprint: &lt;&lt;0, 0, 0, 0&gt;&gt;, key: &lt;&lt;111, 24, 247, 85, 107, 58, 162, 225, 135, 190, 185, 200, 226, 131, 68, 152, 159, 111, 232, 166, 21, 211, 235, 180, 140, 190, 109, 39, 31, 33, 107, 17&gt;&gt;, network: :main, version_number: &lt;&lt;4, 136, 173, 228&gt;&gt; } iex&gt; child_address = master ...&gt; |&gt; BSV.Extended.Children.derive(&quot;m/44&#39;/0&#39;/0&#39;/0/0&quot;) ...&gt; |&gt; BSV.Address.to_string &quot;1F6fuP7HrBY8aeUazXZitaAsgpsJQFfUun&quot; Creating transactions For further details and examples refer to BSV.Transaction, BSV.Transaction.Input, BSV.Transaction.Output and BSV.Transaction.Script. iex&gt; script = %BSV.Transaction.Script{} ...&gt; |&gt; BSV.Transaction.Script.push(:OP_FALSE) ...&gt; |&gt; BSV.Transaction.Script.push(:OP_RETURN) ...&gt; |&gt; BSV.Transaction.Script.push(&quot;hello world&quot;) %BSV.Transaction.Script{chunks: [:OP_FALSE, :OP_RETURN, &quot;hello world&quot;]} iex&gt; output = %BSV.Transaction.Output{script: script} %BSV.Transaction.Output{ amount: 0, satoshis: 0, script: %BSV.Transaction.Script{ chunks: [:OP_FALSE, :OP_RETURN, &quot;hello world&quot;] } } iex&gt; tx = %BSV.Transaction{outputs: [output]} ...&gt; |&gt; BSV.Transaction.serialize(encoding: :hex) &quot;01000000000100000000000000000e006a0b68656c6c6f20776f726c6400000000&quot;"},{"ref":"BSV.Address.html","title":"BSV.Address","type":"module","doc":"Module for calculating any Bitcoin public or private key&#39;s address. A Bitcoin address is calculated by hashing the public key with both the SHA-256 and then RIPEMD alogrithms. The hash is then Base58Check encoded, resulting in the Bitcoin address."},{"ref":"BSV.Address.html#to_string/2","title":"BSV.Address.to_string/2","type":"function","doc":"Calculates and returns the Bitcoin address from the given public or private key. Examples iex&gt; BSV.Crypto.ECDSA.PrivateKey.from_sequence(BSV.Test.ecdsa_key) ...&gt; |&gt; BSV.KeyPair.from_ecdsa_key ...&gt; |&gt; BSV.Address.to_string &quot;18cqNbEBxkAttxcZLuH9LWhZJPd1BNu1A5&quot; iex&gt; BSV.Crypto.ECDSA.PrivateKey.from_sequence(BSV.Test.ecdsa_key) ...&gt; |&gt; BSV.KeyPair.from_ecdsa_key(compressed: false) ...&gt; |&gt; BSV.Address.to_string &quot;1N5Cu7YUPQhcwZaQLDT5KnDpRVKzFDJxsf&quot; iex&gt; BSV.Crypto.ECDSA.PrivateKey.from_sequence(BSV.Test.ecdsa_key) ...&gt; |&gt; BSV.KeyPair.from_ecdsa_key ...&gt; |&gt; BSV.Address.to_string(network: :test) &quot;mo8nfeKAmmc9g56B4UFXARutAPDi1sr7tH&quot;"},{"ref":"BSV.Extended.Children.html","title":"BSV.Extended.Children","type":"module","doc":"Module for deriving children from BIP-32 extended keys."},{"ref":"BSV.Extended.Children.html#derive/2","title":"BSV.Extended.Children.derive/2","type":"function","doc":"Derives a child key from the given extended private or public key, using the specified path. Examples iex&gt; BSV.Extended.PrivateKey.from_seed(BSV.Test.bsv_seed) ...&gt; |&gt; BSV.Extended.Children.derive(&quot;m/44&#39;/0&#39;/0&#39;/0/0&quot;) ...&gt; |&gt; BSV.Address.to_string &quot;1DB7ijqNz91PPTZyv5StZ8DjjMr69chuwH&quot; iex&gt; BSV.Extended.PrivateKey.from_seed(BSV.Test.bsv_seed) ...&gt; |&gt; BSV.Extended.Children.derive(&quot;m/44&#39;/0&#39;/0&#39;/0/9&quot;) ...&gt; |&gt; BSV.Address.to_string &quot;12g4iEyKXndS6qwhLkqxzchep4GwVFUUNJ&quot; iex&gt; BSV.Extended.PrivateKey.from_seed(BSV.Test.bsv_seed) ...&gt; |&gt; BSV.Extended.Children.derive(&quot;m/44&#39;/0&#39;/1&#39;/0/5&quot;) ...&gt; |&gt; BSV.Address.to_string &quot;15JvhMtjeRLewqn2hNSdty4zmEvTJYCPcq&quot;"},{"ref":"BSV.Extended.PrivateKey.html","title":"BSV.Extended.PrivateKey","type":"module","doc":"BIP-32 extended private key module."},{"ref":"BSV.Extended.PrivateKey.html#from_seed/2","title":"BSV.Extended.PrivateKey.from_seed/2","type":"function","doc":"Converts the given BIP39 seed to an extended private key. Options The accepted options are: :encoding - Optionally decode the given seed with either the :base64 or :hex encoding scheme. :network - Specify the intended network. Defaults to :main. Set to :test for testnet. Examples iex&gt; key = BSV.Extended.PrivateKey.from_seed(BSV.Test.bsv_seed) ...&gt; key.__struct__ == BSV.Extended.PrivateKey true"},{"ref":"BSV.Extended.PrivateKey.html#from_string/1","title":"BSV.Extended.PrivateKey.from_string/1","type":"function","doc":"Converts the given xprv string to an extended private key. Examples iex&gt; key = &quot;xprv9s21ZrQH143K2EktC9YxsGeBkkid7yZD7y9gnL7GNkpD6xmF5JoGGgKBQk2tQtA9vAnEfZ6mxhhmULRN5zNwrnDsmX38VGFyBJuhxQPGMsS&quot; ...&gt; |&gt; BSV.Extended.PrivateKey.from_string ...&gt; key.__struct__ == BSV.Extended.PrivateKey true"},{"ref":"BSV.Extended.PrivateKey.html#get_public_key/2","title":"BSV.Extended.PrivateKey.get_public_key/2","type":"function","doc":"Returns the extended public key from the given extended private key. Examples iex&gt; key = BSV.Extended.PrivateKey.from_seed(BSV.Test.bsv_seed) ...&gt; |&gt; BSV.Extended.PrivateKey.get_public_key ...&gt; key.__struct__ == BSV.Extended.PublicKey true"},{"ref":"BSV.Extended.PrivateKey.html#to_string/1","title":"BSV.Extended.PrivateKey.to_string/1","type":"function","doc":"Converts the given extended private key struct to an encoded xprv string. Examples iex&gt; BSV.Extended.PrivateKey.from_seed(BSV.Test.bsv_seed) ...&gt; |&gt; BSV.Extended.PrivateKey.to_string &quot;xprv9s21ZrQH143K2EktC9YxsGeBkkid7yZD7y9gnL7GNkpD6xmF5JoGGgKBQk2tQtA9vAnEfZ6mxhhmULRN5zNwrnDsmX38VGFyBJuhxQPGMsS&quot;"},{"ref":"BSV.Extended.PrivateKey.html#t:t/0","title":"BSV.Extended.PrivateKey.t/0","type":"type","doc":"Extended Private Key"},{"ref":"BSV.Extended.PublicKey.html","title":"BSV.Extended.PublicKey","type":"module","doc":"BIP-32 extended public key module."},{"ref":"BSV.Extended.PublicKey.html#from_private_key/2","title":"BSV.Extended.PublicKey.from_private_key/2","type":"function","doc":"Converts the given extended private key into an extended public key. Options The accepted options are: :compressed - Specify whether to compress the generated public key. Defaults to true. Examples iex&gt; key = BSV.Extended.PrivateKey.from_seed(BSV.Test.bsv_seed) ...&gt; |&gt; BSV.Extended.PublicKey.from_private_key ...&gt; key.__struct__ == BSV.Extended.PublicKey true"},{"ref":"BSV.Extended.PublicKey.html#from_string/1","title":"BSV.Extended.PublicKey.from_string/1","type":"function","doc":"Converts the given xpub string to an extended public key. Examples iex&gt; key = &quot;xpub661MyMwAqRbcEiqMJB5yEQavJnZ7XSH4VC5HaiWsw6MBym6Pcr7WpUdfFykNbZL2JDFFYVe1NpUhJwvaZN44d7R3SmPHSjmUiT8pkR8Yrkk&quot; ...&gt; |&gt; BSV.Extended.PublicKey.from_string ...&gt; key.__struct__ == BSV.Extended.PublicKey true"},{"ref":"BSV.Extended.PublicKey.html#to_string/1","title":"BSV.Extended.PublicKey.to_string/1","type":"function","doc":"Converts the given extended public key struct to an encoded xpub string. Examples iex&gt; BSV.Extended.PrivateKey.from_seed(BSV.Test.bsv_seed) ...&gt; |&gt; BSV.Extended.PublicKey.from_private_key ...&gt; |&gt; BSV.Extended.PublicKey.to_string &quot;xpub661MyMwAqRbcEiqMJB5yEQavJnZ7XSH4VC5HaiWsw6MBym6Pcr7WpUdfFykNbZL2JDFFYVe1NpUhJwvaZN44d7R3SmPHSjmUiT8pkR8Yrkk&quot;"},{"ref":"BSV.Extended.PublicKey.html#t:t/0","title":"BSV.Extended.PublicKey.t/0","type":"type","doc":"Extended Public Key"},{"ref":"BSV.KeyPair.html","title":"BSV.KeyPair","type":"module","doc":"Module for generating and using Bitcoin key pairs. Bitcoin keys are ECDSA keys. Virtually any 256-bit number is a valid private key, and the corresponding point on the secp256k1 curve is the public key."},{"ref":"BSV.KeyPair.html#from_ecdsa_key/2","title":"BSV.KeyPair.from_ecdsa_key/2","type":"function","doc":"Converts ECDSA keys to a BSV key pair. Options The accepted options are: :compressed - Specify whether to compress the given public key. Defaults to true. Examples iex&gt; keypair = BSV.KeyPair.from_ecdsa_key(BSV.Test.bsv_keys) ...&gt; keypair.__struct__ == BSV.KeyPair true"},{"ref":"BSV.KeyPair.html#generate/1","title":"BSV.KeyPair.generate/1","type":"function","doc":"Generates a new BSV key pair. Options The accepted options are: :compressed - Specify whether to compress the generated public key. Defaults to true. Examples iex&gt; keypair = BSV.KeyPair.generate ...&gt; keypair.__struct__ == BSV.KeyPair true"},{"ref":"BSV.KeyPair.html#wif_decode/1","title":"BSV.KeyPair.wif_decode/1","type":"function","doc":"Decodes the given Wallet Import Format (WIF) binary into a BSV key pair. Examples iex&gt; BSV.KeyPair.wif_decode(&quot;KyGHAK8MNohVPdeGPYXveiAbTfLARVrQuJVtd3qMqN41UEnTWDkF&quot;) ...&gt; |&gt; BSV.Address.to_string &quot;18cqNbEBxkAttxcZLuH9LWhZJPd1BNu1A5&quot; iex&gt; BSV.KeyPair.wif_decode(&quot;5JH9eTJyj6bYopGhBztsDd4XvAbFNQkpZEw8AXYoQePtK1r86nu&quot;) ...&gt; |&gt; BSV.Address.to_string &quot;1N5Cu7YUPQhcwZaQLDT5KnDpRVKzFDJxsf&quot;"},{"ref":"BSV.KeyPair.html#wif_encode/1","title":"BSV.KeyPair.wif_encode/1","type":"function","doc":"Encodes the given BSV key pair into a Wallet Import Format (WIF) binary. Examples iex&gt; BSV.Crypto.ECDSA.PrivateKey.from_sequence(BSV.Test.ecdsa_key) ...&gt; |&gt; BSV.KeyPair.from_ecdsa_key ...&gt; |&gt; BSV.KeyPair.wif_encode &quot;KyGHAK8MNohVPdeGPYXveiAbTfLARVrQuJVtd3qMqN41UEnTWDkF&quot; iex&gt; BSV.Crypto.ECDSA.PrivateKey.from_sequence(BSV.Test.ecdsa_key) ...&gt; |&gt; BSV.KeyPair.from_ecdsa_key(compressed: false) ...&gt; |&gt; BSV.KeyPair.wif_encode &quot;5JH9eTJyj6bYopGhBztsDd4XvAbFNQkpZEw8AXYoQePtK1r86nu&quot;"},{"ref":"BSV.KeyPair.html#t:t/0","title":"BSV.KeyPair.t/0","type":"type","doc":"BSV Key Pair"},{"ref":"BSV.Message.html","title":"BSV.Message","type":"module","doc":"Module to sign and verify messages with Bitcoin keys. Is compatible with ElectrumSV and bsv.js. Internally uses libsecp256k1 NIF bindings for compact signatures and public key recovery from signatures."},{"ref":"BSV.Message.html#sign/3","title":"BSV.Message.sign/3","type":"function","doc":"Creates a signature for the given message, using the given private key. Options The accepted options are: :encoding - Encode the returned binary with either the :base64 (default) or :hex encoding scheme. Set to false to return binary signature. Examples BSV.Message.sign(&quot;hello world&quot;, private_key) &quot;Hw9bs6VZ...&quot;"},{"ref":"BSV.Message.html#verify/4","title":"BSV.Message.verify/4","type":"function","doc":"Verify the given message and signature, using the given Bitcoin address or public key. Options The accepted options are: :encoding - Decode the given signature with either the :base64 (default) or :hex encoding scheme. Set to false to accept binary signature. Examples BSV.Crypto.RSA.verify(signature, message, address) true"},{"ref":"BSV.Mnemonic.html","title":"BSV.Mnemonic","type":"module","doc":"Module for generating and restoring mnemonic phrases, for the generation of deterministic keys. Implements BIP-39. A mnemonic phrase is a group of easy to remember words. The phrase can be converted to a binary seed, which in turn is used to generate deterministic keys."},{"ref":"BSV.Mnemonic.html#allowed_lengths/0","title":"BSV.Mnemonic.allowed_lengths/0","type":"function","doc":"Returns a list of the allowed mnemonic entropy lengths."},{"ref":"BSV.Mnemonic.html#from_entropy/1","title":"BSV.Mnemonic.from_entropy/1","type":"function","doc":"Returns a mnemonic phrase derived from the given binary. Examples iex&gt; BSV.Test.mnemonic_entropy ...&gt; |&gt; BSV.Mnemonic.from_entropy &quot;organ boring cushion feature wheat juice quality replace concert baby topic scrub&quot;"},{"ref":"BSV.Mnemonic.html#generate/1","title":"BSV.Mnemonic.generate/1","type":"function","doc":"Generates a new mnemonic phrase from the given entropy length (defaults to 256 bits / 24 words). Examples iex&gt; BSV.Mnemonic.generate ...&gt; |&gt; String.split ...&gt; |&gt; length 24 iex&gt; BSV.Mnemonic.generate(128) ...&gt; |&gt; String.split ...&gt; |&gt; length 12"},{"ref":"BSV.Mnemonic.html#to_entropy/1","title":"BSV.Mnemonic.to_entropy/1","type":"function","doc":"Returns a binary derived from the given mnemonic phrase. Examples iex&gt; &quot;organ boring cushion feature wheat juice quality replace concert baby topic scrub&quot; ...&gt; |&gt; BSV.Mnemonic.to_entropy &lt;&lt;156, 99, 60, 217, 170, 31, 158, 241, 171, 205, 182, 46, 162, 35, 148, 96&gt;&gt;"},{"ref":"BSV.Mnemonic.html#to_seed/2","title":"BSV.Mnemonic.to_seed/2","type":"function","doc":"Returns a wallet seed derived from the given mnemonic phrase and optionally a passphrase. Options The accepted options are: :passphrase - Optionally protect the seed with an additional passphrase :encoding - Optionally encode the seed with either the :base64 or :hex encoding scheme. Examples iex&gt; BSV.Mnemonic.from_entropy(BSV.Test.mnemonic_entropy) ...&gt; |&gt; BSV.Mnemonic.to_seed(encoding: :hex) &quot;380823f725beb7846806d0b88590a0823ea81c0b88cd151f7295772bbe48bbffa9b0f131dce77c4a7168925d466270c12bc0073db917da9f2bb1f4ac59e9fa3b&quot; iex&gt; BSV.Mnemonic.from_entropy(BSV.Test.mnemonic_entropy) ...&gt; |&gt; BSV.Mnemonic.to_seed(passphrase: &quot;my wallet&quot;) ...&gt; |&gt; byte_size 64"},{"ref":"BSV.Mnemonic.html#words/0","title":"BSV.Mnemonic.words/0","type":"function","doc":"Returns the mnemonic word list."},{"ref":"BSV.Mnemonic.html#t:t/0","title":"BSV.Mnemonic.t/0","type":"type","doc":"Mnemonic phrase"},{"ref":"BSV.Transaction.html","title":"BSV.Transaction","type":"module","doc":"Module for the construction, parsing and serialization of Bitcoin transactions."},{"ref":"BSV.Transaction.html#get_txid/1","title":"BSV.Transaction.get_txid/1","type":"function","doc":"Returns the given transaction&#39;s txid, which is a double SHA-256 hash of the transaction, reversed."},{"ref":"BSV.Transaction.html#parse/2","title":"BSV.Transaction.parse/2","type":"function","doc":"Parse the given binary into a transaction. Returns a tuple containing the transaction input and the remaining binary data. Options The accepted options are: :encoding - Optionally decode the binary with either the :base64 or :hex encoding scheme. Examples BSV.Transaction.parse(data) {%BSV.Trasaction{}, &quot;&quot;}"},{"ref":"BSV.Transaction.html#serialize/2","title":"BSV.Transaction.serialize/2","type":"function","doc":"Serialises the given transaction into a binary. Options The accepted options are: :encode - Optionally encode the returned binary with either the :base64 or :hex encoding scheme. Examples BSV.Transaction.Input.serialize(input) &lt;&lt;binary&gt;&gt;"},{"ref":"BSV.Transaction.html#t:t/0","title":"BSV.Transaction.t/0","type":"type","doc":"Bitcoin Transaction"},{"ref":"BSV.Transaction.Input.html","title":"BSV.Transaction.Input","type":"module","doc":"Module for parsing and serialising transaction inputs."},{"ref":"BSV.Transaction.Input.html#parse/2","title":"BSV.Transaction.Input.parse/2","type":"function","doc":"Parse the given binary into a transaction input. Returns a tuple containing the transaction input and the remaining binary data. Options The accepted options are: :encoding - Optionally decode the binary with either the :base64 or :hex encoding scheme. Examples BSV.Transaction.Input.parse(data) {%BSV.Trasaction.Input{}, &quot;&quot;}"},{"ref":"BSV.Transaction.Input.html#serialize/2","title":"BSV.Transaction.Input.serialize/2","type":"function","doc":"Serialises the given transaction input struct into a binary. Options The accepted options are: :encode - Optionally encode the returned binary with either the :base64 or :hex encoding scheme. Examples BSV.Transaction.Input.serialize(input) &lt;&lt;binary&gt;&gt;"},{"ref":"BSV.Transaction.Input.html#t:t/0","title":"BSV.Transaction.Input.t/0","type":"type","doc":"Transaction input"},{"ref":"BSV.Transaction.Output.html","title":"BSV.Transaction.Output","type":"module","doc":"Module for parsing and serialising transaction outputs."},{"ref":"BSV.Transaction.Output.html#parse/2","title":"BSV.Transaction.Output.parse/2","type":"function","doc":"Parse the given binary into a single transaction output. Returns a tuple containing the transaction output and the remaining binary data. Options The accepted options are: :encoding - Optionally decode the binary with either the :base64 or :hex encoding scheme. Examples BSV.Transaction.Output.parse(data) {%BSV.Trasaction.Output{}, &quot;&quot;}"},{"ref":"BSV.Transaction.Output.html#serialize/2","title":"BSV.Transaction.Output.serialize/2","type":"function","doc":"Serialises the given transaction output struct into a binary. Options The accepted options are: :encode - Optionally encode the returned binary with either the :base64 or :hex encoding scheme. Examples BSV.Transaction.Output.serialize(output) &lt;&lt;binary&gt;&gt;"},{"ref":"BSV.Transaction.Output.html#t:t/0","title":"BSV.Transaction.Output.t/0","type":"type","doc":"Transaction output"},{"ref":"BSV.Transaction.Script.html","title":"BSV.Transaction.Script","type":"module","doc":"Module for the construction, parsing and serialization of transactions to and from binary data. Examples iex&gt; %BSV.Transaction.Script{} ...&gt; |&gt; BSV.Transaction.Script.push(:OP_FALSE) ...&gt; |&gt; BSV.Transaction.Script.push(:OP_RETURN) ...&gt; |&gt; BSV.Transaction.Script.push(&quot;hello world&quot;) ...&gt; |&gt; BSV.Transaction.Script.serialize(encoding: :hex) &quot;006a0b68656c6c6f20776f726c64&quot; iex&gt; &quot;006a0b68656c6c6f20776f726c64&quot; ...&gt; |&gt; BSV.Transaction.Script.parse(encoding: :hex) %BSV.Transaction.Script{ chunks: [:OP_FALSE, :OP_RETURN, &quot;hello world&quot;] }"},{"ref":"BSV.Transaction.Script.html#get_op_code/1","title":"BSV.Transaction.Script.get_op_code/1","type":"function","doc":"Returns a tuple caintaining the OP code and OP code byte number, depending on the given OP code name or integer. Examples iex&gt; BSV.Transaction.Script.get_op_code :OP_RETURN {:OP_RETURN, 106} iex&gt; BSV.Transaction.Script.get_op_code &quot;op_return&quot; {:OP_RETURN, 106} iex&gt; BSV.Transaction.Script.get_op_code 106 {:OP_RETURN, 106} iex&gt; BSV.Transaction.Script.get_op_code :UNKNOWN_CODE nil"},{"ref":"BSV.Transaction.Script.html#op_codes/0","title":"BSV.Transaction.Script.op_codes/0","type":"function","doc":"Returns a map of all OP codes."},{"ref":"BSV.Transaction.Script.html#parse/2","title":"BSV.Transaction.Script.parse/2","type":"function","doc":"Parses the given binary into a transaction script. Options The accepted options are: :encoding - Optionally decode the binary with either the :base64 or :hex encoding scheme. Examples iex&gt; &quot;76a9146afc0d6bb578282ac0f6ad5c5af2294c1971210888ac&quot; ...&gt; |&gt; BSV.Transaction.Script.parse(encoding: :hex) %BSV.Transaction.Script{ chunks: [ :OP_DUP, :OP_HASH160, &lt;&lt;106, 252, 13, 107, 181, 120, 40, 42, 192, 246, 173, 92, 90, 242, 41, 76, 25, 113, 33, 8&gt;&gt;, :OP_EQUALVERIFY, :OP_CHECKSIG ] }"},{"ref":"BSV.Transaction.Script.html#push/2","title":"BSV.Transaction.Script.push/2","type":"function","doc":"Pushes a chunk into the given transaction script. The chunk can be any binary value or OP code. Examples iex&gt; %BSV.Transaction.Script{} ...&gt; |&gt; BSV.Transaction.Script.push(:OP_DUP) ...&gt; |&gt; BSV.Transaction.Script.push(:OP_HASH160) ...&gt; |&gt; BSV.Transaction.Script.push(&lt;&lt;106, 252, 13, 107, 181, 120, 40, 42, 192, 246, 173, 92, 90, 242, 41, 76, 25, 113, 33, 8&gt;&gt;) ...&gt; |&gt; BSV.Transaction.Script.push(:OP_EQUALVERIFY) ...&gt; |&gt; BSV.Transaction.Script.push(:OP_CHECKSIG) %BSV.Transaction.Script{ chunks: [ :OP_DUP, :OP_HASH160, &lt;&lt;106, 252, 13, 107, 181, 120, 40, 42, 192, 246, 173, 92, 90, 242, 41, 76, 25, 113, 33, 8&gt;&gt;, :OP_EQUALVERIFY, :OP_CHECKSIG ] }"},{"ref":"BSV.Transaction.Script.html#serialize/2","title":"BSV.Transaction.Script.serialize/2","type":"function","doc":"Serialises the given script into a binary. Options The accepted options are: :encode - Optionally encode the returned binary with either the :base64 or :hex encoding scheme. Examples iex&gt; %BSV.Transaction.Script{} ...&gt; |&gt; BSV.Transaction.Script.push(:OP_DUP) ...&gt; |&gt; BSV.Transaction.Script.push(:OP_HASH160) ...&gt; |&gt; BSV.Transaction.Script.push(&lt;&lt;106, 252, 13, 107, 181, 120, 40, 42, 192, 246, 173, 92, 90, 242, 41, 76, 25, 113, 33, 8&gt;&gt;) ...&gt; |&gt; BSV.Transaction.Script.push(:OP_EQUALVERIFY) ...&gt; |&gt; BSV.Transaction.Script.push(:OP_CHECKSIG) ...&gt; |&gt; BSV.Transaction.Script.serialize(encoding: :hex) &quot;76a9146afc0d6bb578282ac0f6ad5c5af2294c1971210888ac&quot;"},{"ref":"BSV.Transaction.Script.html#t:t/0","title":"BSV.Transaction.Script.t/0","type":"type","doc":"Bitcoin Script"},{"ref":"BSV.Util.html","title":"BSV.Util","type":"module","doc":"A collection of commonly used helper methods."},{"ref":"BSV.Util.html#decode/2","title":"BSV.Util.decode/2","type":"function","doc":"Decodes the given binary data with the specified encoding scheme. Options The accepted encoding schemes are: :base64 - Encodes the binary using Base64 :hex - Encodes the binary using Base16 (hexidecimal), using lower character case Examples iex&gt; BSV.Util.decode(&quot;aGVsbG8gd29ybGQ=&quot;, :base64) &quot;hello world&quot; iex&gt; BSV.Util.decode(&quot;68656c6c6f20776f726c64&quot;, :hex) &quot;hello world&quot;"},{"ref":"BSV.Util.html#encode/2","title":"BSV.Util.encode/2","type":"function","doc":"Encodes the given binary data with the specified encoding scheme. Options The accepted encoding schemes are: :base64 - Encodes the binary using Base64 :hex - Encodes the binary using Base16 (hexidecimal), using lower character case Examples iex&gt; BSV.Util.encode(&quot;hello world&quot;, :base64) &quot;aGVsbG8gd29ybGQ=&quot; iex&gt; BSV.Util.encode(&quot;hello world&quot;, :hex) &quot;68656c6c6f20776f726c64&quot;"},{"ref":"BSV.Util.html#random_bytes/1","title":"BSV.Util.random_bytes/1","type":"function","doc":"Generates random bits for the given number of bytes. Examples iex&gt; iv = BSV.Util.random_bytes(16) ...&gt; bit_size(iv) 128"},{"ref":"BSV.Util.html#reverse_bin/1","title":"BSV.Util.reverse_bin/1","type":"function","doc":"Reverses the order of the given binary data. Examples iex&gt; BSV.Util.reverse_bin(&quot;abcdefg&quot;) &quot;gfedcba&quot;"},{"ref":"BSV.Util.VarBin.html","title":"BSV.Util.VarBin","type":"module","doc":"Module for parsing and serializing variable length binary data as integers, binaries and structs."},{"ref":"BSV.Util.VarBin.html#parse_bin/1","title":"BSV.Util.VarBin.parse_bin/1","type":"function","doc":"Parses the given binary into a chunk of binary data, using the first byte(s) to determing the size of the chunk. Returns a tuple containing the chunk and any remaining binary data. Examples iex&gt; BSV.Util.VarBin.parse_bin(&lt;&lt;5, 104, 101, 108, 108, 111&gt;&gt;) {&quot;hello&quot;, &quot;&quot;}"},{"ref":"BSV.Util.VarBin.html#parse_int/1","title":"BSV.Util.VarBin.parse_int/1","type":"function","doc":"Parses the given binary into an integer. Returns a tuple containing the decoded integer and any remaining binary data. Examples iex&gt; BSV.Util.VarBin.parse_int(&lt;&lt;253, 4, 1&gt;&gt;) {260, &quot;&quot;} iex&gt; BSV.Util.VarBin.parse_int(&lt;&lt;254, 0, 225, 245, 5&gt;&gt;) {100_000_000, &quot;&quot;}"},{"ref":"BSV.Util.VarBin.html#parse_items/2","title":"BSV.Util.VarBin.parse_items/2","type":"function","doc":"Parses the given binary into a list of parsed structs, using the first byte(s) to determing the number of items, and calling the given callback to parse each repsective chunk of data. Returns a tuple containing a list of parsed items and any remaining binary data. Examples BSV.Util.VarBin.parse_items(data, &amp;BSV.Transaction.Input.parse/1) {[ %BSV.Trasaction.Input{}, %BSV.Trasaction.Input{} ], &quot;&quot;}"},{"ref":"BSV.Util.VarBin.html#serialize_bin/1","title":"BSV.Util.VarBin.serialize_bin/1","type":"function","doc":"Prefixes the given binary with a variable length integer to indicate the size of the following binary, Examples iex&gt; BSV.Util.VarBin.serialize_bin(&quot;hello&quot;) &lt;&lt;5, 104, 101, 108, 108, 111&gt;&gt;"},{"ref":"BSV.Util.VarBin.html#serialize_int/1","title":"BSV.Util.VarBin.serialize_int/1","type":"function","doc":"Serializes the given integer into a binary. Examples iex&gt; BSV.Util.VarBin.serialize_int(260) &lt;&lt;253, 4, 1&gt;&gt; iex&gt; BSV.Util.VarBin.serialize_int(100_000_000) &lt;&lt;254, 0, 225, 245, 5&gt;&gt;"},{"ref":"BSV.Util.VarBin.html#serialize_items/2","title":"BSV.Util.VarBin.serialize_items/2","type":"function","doc":"Serializes the given list of items into a binary, first by prefixing the binary with a variable length integer to indicate the number of items, and then by calling the given callback to serialize each respective item. Examples [ %BSV.Trasaction.Input{}, %BSV.Trasaction.Input{} ] |&gt; BSV.Util.VarBin.serialize_items(data, &amp;BSV.Transaction.Input.serialize/1) &lt;&lt; data &gt;&gt;"},{"ref":"BSV.Crypto.AES.html","title":"BSV.Crypto.AES","type":"module","doc":"Functions for use with AES symmetric cryptography. Examples iex&gt; secret = BSV.Crypto.AES.generate_secret ...&gt; ...&gt; &quot;hello world&quot; ...&gt; |&gt; BSV.Crypto.AES.encrypt(:gcm, secret) ...&gt; |&gt; BSV.Crypto.AES.decrypt(:gcm, secret) &quot;hello world&quot;"},{"ref":"BSV.Crypto.AES.html#cipher_modes/0","title":"BSV.Crypto.AES.cipher_modes/0","type":"function","doc":"Returns a list of supported cypher modes."},{"ref":"BSV.Crypto.AES.html#decrypt/4","title":"BSV.Crypto.AES.decrypt/4","type":"function","doc":"Decrypts the given ciphertext using the specified cipher mode with the given secret key. Options The accepted cipher modes are: :gcm - Galois/Counter Mode (GCM) :cbc - Cipher Block Chaining (CBC) :ctr - Counter (CTR) The accepted options are: :aad - If Additional Authentication Data was specified at encryption, it must be used here to successfully decrypt. :encoding - Optionally decode the given cipher text with either the :base64 or :hex encoding scheme. :iv - If your own initialization vector was specified at encryption, it must be used here to successfully decrypt. Examples iex&gt; &quot;Mku/VQR8uf3UIkCpoALkvWhtCUs+ASpfa9q76zewa0Y6G9t/5u5n&quot; ...&gt; |&gt; BSV.Crypto.AES.decrypt(:gcm, BSV.Test.symetric_key, iv: BSV.Test.iv12, encoding: :base64, aad: &quot;MyAAD&quot;) &quot;hello world&quot; iex&gt; &quot;quZoaDPv4OXNC5Ze2wmbCA==&quot; ...&gt; |&gt; BSV.Crypto.AES.decrypt(:cbc, BSV.Test.symetric_key, iv: BSV.Test.iv16, encoding: :base64) &quot;hello world&quot; iex&gt; &quot;cdf91fda732325cf96de03&quot; ...&gt; |&gt; BSV.Crypto.AES.decrypt(:ctr, BSV.Test.symetric_key, iv: BSV.Test.iv16, encoding: :hex) &quot;hello world&quot;"},{"ref":"BSV.Crypto.AES.html#encrypt/4","title":"BSV.Crypto.AES.encrypt/4","type":"function","doc":"Encrypts the given data using the specified cipher mode with the given secret key. Options The accepted cipher modes are: :gcm - Galois/Counter Mode (GCM) :cbc - Cipher Block Chaining (CBC) :ctr - Counter (CTR) The accepted options are: :aad - Provide your own Additional Authentication Data (only used in :gcm mode). If not provided, defaults to &quot;BSV.Crypto.AES&quot;. :encoding - Optionally encode the returned cipher text with either the :base64 or :hex encoding scheme. :iv - Provide your own initialization vector. In :cbc and :ctr mode this is necessary as the same vector is needed to decrypt. In :gcm mode it is unnecessary as a random vector is generated and encoded in the returned cipher text. Examples iex&gt; BSV.Crypto.AES.encrypt(&quot;hello world&quot;, :gcm, BSV.Test.symetric_key, iv: BSV.Test.iv12, aad: &quot;MyAAD&quot;) &lt;&lt;50, 75, 191, 85, 4, 124, 185, 253, 212, 34, 64, 169, 160, 2, 228, 189, 104, 109, 9, 75, 62, 1, 42, 95, 107, 218, 187, 235, 55, 176, 107, 70, 58, 27, 219, 127, 230, 238, 103&gt;&gt; iex&gt; BSV.Crypto.AES.encrypt(&quot;hello world&quot;, :gcm, BSV.Test.symetric_key, iv: BSV.Test.iv12, aad: &quot;MyAAD&quot;, encoding: :base64) &quot;Mku/VQR8uf3UIkCpoALkvWhtCUs+ASpfa9q76zewa0Y6G9t/5u5n&quot; iex&gt; BSV.Crypto.AES.encrypt(&quot;hello world&quot;, :cbc, BSV.Test.symetric_key, iv: BSV.Test.iv16, encoding: :base64) &quot;quZoaDPv4OXNC5Ze2wmbCA==&quot; iex&gt; BSV.Crypto.AES.encrypt(&quot;hello world&quot;, :ctr, BSV.Test.symetric_key, iv: BSV.Test.iv16, encoding: :hex) &quot;cdf91fda732325cf96de03&quot;"},{"ref":"BSV.Crypto.AES.html#generate_secret/0","title":"BSV.Crypto.AES.generate_secret/0","type":"function","doc":"Generate a 256 bit random secret key. Examples iex&gt; BSV.Crypto.AES.generate_secret ...&gt; |&gt; byte_size 32"},{"ref":"BSV.Crypto.ECDSA.html","title":"BSV.Crypto.ECDSA","type":"module","doc":"Functions for use with ECDSA asymmetric cryptography. Examples iex&gt; private_key = BSV.Crypto.ECDSA.generate_key ...&gt; public_key = BSV.Crypto.ECDSA.PrivateKey.get_public_key(private_key) ...&gt; ...&gt; &quot;hello world&quot; ...&gt; |&gt; BSV.Crypto.ECDSA.sign(private_key) ...&gt; |&gt; BSV.Crypto.ECDSA.verify(&quot;hello world&quot;, public_key) true"},{"ref":"BSV.Crypto.ECDSA.html#generate_key/1","title":"BSV.Crypto.ECDSA.generate_key/1","type":"function","doc":"Generates a new ECDSA private key. Options The accepted options are: :named_curve - Specify the elliptic curve name. Defaults to :secp256k1. Examples iex&gt; private_key = BSV.Crypto.ECDSA.generate_key ...&gt; private_key.__struct__ == BSV.Crypto.ECDSA.PrivateKey true"},{"ref":"BSV.Crypto.ECDSA.html#generate_key_pair/1","title":"BSV.Crypto.ECDSA.generate_key_pair/1","type":"function","doc":"Generates a new ECDSA public and private key pair, returned as a tuple containing two binaries. Options The accepted options are: :named_curve - Specify the elliptic curve name. Defaults to :secp256k1. :private_key - When a private key binary is given, it will be returned with its public key. Examples iex&gt; BSV.Crypto.ECDSA.generate_key_pair ...&gt; |&gt; is_tuple true iex&gt; ecdsa_key = BSV.Crypto.ECDSA.PrivateKey.from_sequence(BSV.Test.ecdsa_key) ...&gt; ...&gt; public_key = BSV.Crypto.ECDSA.generate_key_pair(private_key: ecdsa_key.private_key) ...&gt; |&gt; elem(0) ...&gt; public_key == ecdsa_key.public_key true"},{"ref":"BSV.Crypto.ECDSA.html#pem_decode/1","title":"BSV.Crypto.ECDSA.pem_decode/1","type":"function","doc":"Decodes the given PEM string into a ECDSA key. Examples iex&gt; ecdsa_key = BSV.Crypto.ECDSA.PrivateKey.from_sequence(BSV.Test.ecdsa_key) ...&gt; pem = BSV.Crypto.ECDSA.pem_encode(ecdsa_key) ...&gt; ...&gt; imported_key = BSV.Crypto.ECDSA.pem_decode(pem) ...&gt; imported_key == ecdsa_key true"},{"ref":"BSV.Crypto.ECDSA.html#pem_encode/1","title":"BSV.Crypto.ECDSA.pem_encode/1","type":"function","doc":"Encodes the given public or private key into a PEM string. Examples iex&gt; BSV.Crypto.ECDSA.PrivateKey.from_sequence(BSV.Test.ecdsa_key) ...&gt; |&gt; BSV.Crypto.ECDSA.pem_encode ...&gt; |&gt; String.starts_with?(&quot;-----BEGIN EC PRIVATE KEY-----&quot;) true"},{"ref":"BSV.Crypto.ECDSA.html#sign/3","title":"BSV.Crypto.ECDSA.sign/3","type":"function","doc":"Creates a signature for the given message, using the given private key. Options The accepted options are: :named_curve - Specific the elliptic curve name. Defaults to :secp256k1. :encoding - Optionally encode the returned binary with either the :base64 or :hex encoding scheme. Examples BSV.Crypto.ECDSA.sign(&quot;hello world&quot;, private_key, encoding: :base64) &lt;&lt; signature &gt;&gt;"},{"ref":"BSV.Crypto.ECDSA.html#verify/4","title":"BSV.Crypto.ECDSA.verify/4","type":"function","doc":"Verify the given message and signature, using the given public key. Options The accepted options are: :encoding - Optionally decode the given signature with either the :base64 or :hex encoding scheme. :named_curve - Specific the elliptic curve name. Defaults to :secp256k1. Examples BSV.Crypto.ECDSA.verify(signature, message, public_key) true"},{"ref":"BSV.Crypto.ECDSA.PrivateKey.html","title":"BSV.Crypto.ECDSA.PrivateKey","type":"module","doc":"ECDSA Private Key module."},{"ref":"BSV.Crypto.ECDSA.PrivateKey.html#as_sequence/1","title":"BSV.Crypto.ECDSA.PrivateKey.as_sequence/1","type":"function","doc":"Converts the given ECDSA private key to an Erlang ECDSA key sequence. Convert a BSV.Crypto.ECDSA.PrivateKey.t/0 to a BSV.Crypto.ECDSA.PrivateKey.sequence/0. Examples iex&gt; ecdsa_key = BSV.Crypto.ECDSA.PrivateKey.from_sequence(BSV.Test.ecdsa_key) ...&gt; ...&gt; BSV.Crypto.ECDSA.PrivateKey.as_sequence(ecdsa_key) ...&gt; |&gt; is_tuple true"},{"ref":"BSV.Crypto.ECDSA.PrivateKey.html#from_sequence/1","title":"BSV.Crypto.ECDSA.PrivateKey.from_sequence/1","type":"function","doc":"Converts the given Erlang ECDSA key sequence to a ECDSA private key. Examples iex&gt; ecdsa_key = BSV.Crypto.ECDSA.PrivateKey.from_sequence(BSV.Test.ecdsa_key) ...&gt; ecdsa_key.__struct__ == BSV.Crypto.ECDSA.PrivateKey true"},{"ref":"BSV.Crypto.ECDSA.PrivateKey.html#get_public_key/1","title":"BSV.Crypto.ECDSA.PrivateKey.get_public_key/1","type":"function","doc":"Returns the public key from the given ECDSA private key. Examples iex&gt; public_key = BSV.Crypto.ECDSA.PrivateKey.from_sequence(BSV.Test.ecdsa_key) ...&gt; |&gt; BSV.Crypto.ECDSA.PrivateKey.get_public_key ...&gt; public_key.__struct__ == BSV.Crypto.ECDSA.PublicKey true"},{"ref":"BSV.Crypto.ECDSA.PrivateKey.html#t:sequence/0","title":"BSV.Crypto.ECDSA.PrivateKey.sequence/0","type":"type","doc":"Erlang ECDSA Private Key sequence"},{"ref":"BSV.Crypto.ECDSA.PrivateKey.html#t:t/0","title":"BSV.Crypto.ECDSA.PrivateKey.t/0","type":"type","doc":"ECDSA Private Key"},{"ref":"BSV.Crypto.ECDSA.PublicKey.html","title":"BSV.Crypto.ECDSA.PublicKey","type":"module","doc":"ECDSA Private Key module."},{"ref":"BSV.Crypto.ECDSA.PublicKey.html#as_sequence/1","title":"BSV.Crypto.ECDSA.PublicKey.as_sequence/1","type":"function","doc":"Converts the given ECDSA public key struct to an Erlang EC point sequence. Examples iex&gt; public_key = BSV.Crypto.ECDSA.PrivateKey.from_sequence(BSV.Test.ecdsa_key) ...&gt; |&gt; BSV.Crypto.ECDSA.PrivateKey.get_public_key ...&gt; ...&gt; BSV.Crypto.ECDSA.PublicKey.as_sequence(public_key) ...&gt; |&gt; is_tuple true"},{"ref":"BSV.Crypto.ECDSA.PublicKey.html#compress/1","title":"BSV.Crypto.ECDSA.PublicKey.compress/1","type":"function","doc":"Converts the given public key into a compressed binary Examples iex&gt; public_key = BSV.Crypto.ECDSA.PrivateKey.from_sequence(BSV.Test.ecdsa_key) ...&gt; |&gt; BSV.Crypto.ECDSA.PrivateKey.get_public_key ...&gt; ...&gt; BSV.Crypto.ECDSA.PublicKey.compress(public_key) ...&gt; |&gt; byte_size 33"},{"ref":"BSV.Crypto.ECDSA.PublicKey.html#t:point/0","title":"BSV.Crypto.ECDSA.PublicKey.point/0","type":"type","doc":"Erlang ECDSA Public Key sequence"},{"ref":"BSV.Crypto.ECDSA.PublicKey.html#t:t/0","title":"BSV.Crypto.ECDSA.PublicKey.t/0","type":"type","doc":"ECDSA Public Key"},{"ref":"BSV.Crypto.ECIES.html","title":"BSV.Crypto.ECIES","type":"module","doc":"Functions for use with ECIES asymmetric encryption. Is compatible with ElectrumSV and bsv.js. Internally uses libsecp256k1 NIF bindings. Examples iex&gt; {public_key, private_key} = BSV.Crypto.ECDSA.generate_key_pair ...&gt; ...&gt; &quot;hello world&quot; ...&gt; |&gt; BSV.Crypto.ECIES.encrypt(public_key) ...&gt; |&gt; BSV.Crypto.ECIES.decrypt(private_key) &quot;hello world&quot;"},{"ref":"BSV.Crypto.ECIES.html#decrypt/3","title":"BSV.Crypto.ECIES.decrypt/3","type":"function","doc":"Decrypts the encrypted data with the given private key. Options The accepted options are: :encoding - Optionally decode the given cipher text with either the :base64 or :hex encoding scheme. Examples BSV.Crypto.ECIES.decrypt(encrypted_binary, private_key) &lt;&lt; decrypted binary &gt;&gt;"},{"ref":"BSV.Crypto.ECIES.html#encrypt/3","title":"BSV.Crypto.ECIES.encrypt/3","type":"function","doc":"Encrypts the given data with the given public key. Options The accepted options are: :encoding - Optionally encode the returned binary with either the :base64 or :hex encoding scheme. Examples BSV.Crypto.ECIES.encrypt(&quot;hello world&quot;, public_key) &lt;&lt; encrypted binary &gt;&gt;"},{"ref":"BSV.Crypto.Hash.html","title":"BSV.Crypto.Hash","type":"module","doc":"A collection of one-way hashing functions."},{"ref":"BSV.Crypto.Hash.html#hash/3","title":"BSV.Crypto.Hash.hash/3","type":"function","doc":"Computes a hash of the given data, using the specified hash algorithm. Options The accepted hash algorithms are: :md5 - MD5 message-digest algorithm (128 bit) :ripemd160 - RIPE Message Digest algorithm (160 bit) :sha - Secure Hash Algorithm 1 (SHA-1) (160 bit) :sha224 - Secure Hash Algorithm 2 (SHA-2) (224 bit) :sha256 - Secure Hash Algorithm 2 (SHA-2) (256 bit) :sha384 - Secure Hash Algorithm 2 (SHA-2) (384 bit) :sha512 - Secure Hash Algorithm 2 (SHA-2) (512 bit) The accepted options are: :encoding - Optionally encode the returned hash with either the :base64 or :hex encoding scheme. Examples iex&gt; BSV.Crypto.Hash.hash(&quot;hello world&quot;, :sha256) &lt;&lt;185, 77, 39, 185, 147, 77, 62, 8, 165, 46, 82, 215, 218, 125, 171, 250, 196, 132, 239, 227, 122, 83, 128, 238, 144, 136, 247, 172, 226, 239, 205, 233&gt;&gt; iex&gt; BSV.Crypto.Hash.hash(&quot;hello world&quot;, :sha256, encoding: :hex) &quot;b94d27b9934d3e08a52e52d7da7dabfac484efe37a5380ee9088f7ace2efcde9&quot; iex&gt; BSV.Crypto.Hash.hash(&quot;hello world&quot;, :sha256, encoding: :base64) &quot;uU0nuZNNPgilLlLX2n2r+sSE7+N6U4DukIj3rOLvzek=&quot;"},{"ref":"BSV.Crypto.Hash.html#hash_algorithms/0","title":"BSV.Crypto.Hash.hash_algorithms/0","type":"function","doc":"Returns a list of supported hash algorithms."},{"ref":"BSV.Crypto.Hash.html#hmac/4","title":"BSV.Crypto.Hash.hmac/4","type":"function","doc":""},{"ref":"BSV.Crypto.Hash.html#ripemd160/2","title":"BSV.Crypto.Hash.ripemd160/2","type":"function","doc":"Computes the RIPEMD hash of a given input, outputting 160 bits. See BSV.Crypto.Hash.hash/3 for the accepted options. Examples iex&gt; BSV.Crypto.Hash.ripemd160(&quot;hello world&quot;) &lt;&lt;152, 198, 21, 120, 76, 203, 95, 229, 147, 111, 188, 12, 190, 157, 253, 180, 8, 217, 47, 15&gt;&gt; iex&gt; BSV.Crypto.Hash.ripemd160(&quot;hello world&quot;, encoding: :hex) &quot;98c615784ccb5fe5936fbc0cbe9dfdb408d92f0f&quot;"},{"ref":"BSV.Crypto.Hash.html#sha1/2","title":"BSV.Crypto.Hash.sha1/2","type":"function","doc":"Computes the SHA-1 hash of a given input, outputting 160 bits. See BSV.Crypto.Hash.hash/3 for the accepted options. Examples iex&gt; BSV.Crypto.Hash.sha1(&quot;hello world&quot;) &lt;&lt;42, 174, 108, 53, 201, 79, 207, 180, 21, 219, 233, 95, 64, 139, 156, 233, 30, 232, 70, 237&gt;&gt; iex&gt; BSV.Crypto.Hash.sha1(&quot;hello world&quot;, encoding: :hex) &quot;2aae6c35c94fcfb415dbe95f408b9ce91ee846ed&quot;"},{"ref":"BSV.Crypto.Hash.html#sha256/2","title":"BSV.Crypto.Hash.sha256/2","type":"function","doc":"Computes the SHA-2 hash of a given input, outputting 256 bits. See BSV.Crypto.Hash.hash/3 for the accepted options. Examples iex&gt; BSV.Crypto.Hash.sha256(&quot;hello world&quot;) &lt;&lt;185, 77, 39, 185, 147, 77, 62, 8, 165, 46, 82, 215, 218, 125, 171, 250, 196, 132, 239, 227, 122, 83, 128, 238, 144, 136, 247, 172, 226, 239, 205, 233&gt;&gt; iex&gt; BSV.Crypto.Hash.sha256(&quot;hello world&quot;, encoding: :hex) &quot;b94d27b9934d3e08a52e52d7da7dabfac484efe37a5380ee9088f7ace2efcde9&quot;"},{"ref":"BSV.Crypto.Hash.html#sha256_ripemd160/2","title":"BSV.Crypto.Hash.sha256_ripemd160/2","type":"function","doc":"Computes a RIPEMD0160 hash of a SHA256 hash, outputting 160 bits. This is commonly used inside Bitcoin, particularly for Bitcoin addresses. See BSV.Crypto.Hash.hash/3 for the accepted options. Examples iex&gt; BSV.Crypto.Hash.sha256_ripemd160(&quot;hello world&quot;) &lt;&lt;215, 213, 238, 120, 36, 255, 147, 249, 76, 48, 85, 175, 147, 130, 200, 108, 104, 181, 202, 146&gt;&gt; iex&gt; BSV.Crypto.Hash.sha256_ripemd160(&quot;hello world&quot;, encoding: :hex) &quot;d7d5ee7824ff93f94c3055af9382c86c68b5ca92&quot;"},{"ref":"BSV.Crypto.Hash.html#sha256_sha256/2","title":"BSV.Crypto.Hash.sha256_sha256/2","type":"function","doc":"Computes a double SHA256 hash. This hash function is commonly used inside Bitcoin, particularly for the hash of a block and the hash of a transaction. See BSV.Crypto.Hash.hash/3 for the accepted options. Examples iex&gt; BSV.Crypto.Hash.sha256_sha256(&quot;hello world&quot;) &lt;&lt;188, 98, 212, 184, 13, 158, 54, 218, 41, 193, 108, 93, 77, 159, 17, 115, 31, 54, 5, 44, 114, 64, 26, 118, 194, 60, 15, 181, 169, 183, 68, 35&gt;&gt; iex&gt; BSV.Crypto.Hash.sha256_sha256(&quot;hello world&quot;, encoding: :hex) &quot;bc62d4b80d9e36da29c16c5d4d9f11731f36052c72401a76c23c0fb5a9b74423&quot;"},{"ref":"BSV.Crypto.Hash.html#sha512/2","title":"BSV.Crypto.Hash.sha512/2","type":"function","doc":"Computes the SHA-2 hash of a given input, outputting 512 bits. See BSV.Crypto.Hash.hash/3 for the accepted options. Examples iex&gt; BSV.Crypto.Hash.sha512(&quot;hello world&quot;, encoding: :hex) &quot;309ecc489c12d6eb4cc40f50c902f2b4d0ed77ee511a7c7a9bcd3ca86d4cd86f989dd35bc5ff499670da34255b45b0cfd830e81f605dcf7dc5542e93ae9cd76f&quot; iex&gt; BSV.Crypto.Hash.sha512(&quot;hello world&quot;, encoding: :base64) &quot;MJ7MSJwS1utMxA9QyQLytNDtd+5RGnx6m808qG1M2G+YndNbxf9JlnDaNCVbRbDP2DDoH2Bdz33FVC6TrpzXbw==&quot;"},{"ref":"BSV.Crypto.RSA.html","title":"BSV.Crypto.RSA","type":"module","doc":"Functions for use with RSA asymmetric cryptography. Examples iex&gt; private_key = BSV.Crypto.RSA.generate_key ...&gt; public_key = BSV.Crypto.RSA.PrivateKey.get_public_key(private_key) ...&gt; ...&gt; &quot;hello world&quot; ...&gt; |&gt; BSV.Crypto.RSA.encrypt(public_key) ...&gt; |&gt; BSV.Crypto.RSA.decrypt(private_key) &quot;hello world&quot; iex&gt; private_key = BSV.Crypto.RSA.generate_key ...&gt; public_key = BSV.Crypto.RSA.PrivateKey.get_public_key(private_key) ...&gt; ...&gt; &quot;hello world&quot; ...&gt; |&gt; BSV.Crypto.RSA.sign(private_key) ...&gt; |&gt; BSV.Crypto.RSA.verify(&quot;hello world&quot;, public_key) true"},{"ref":"BSV.Crypto.RSA.html#decrypt/3","title":"BSV.Crypto.RSA.decrypt/3","type":"function","doc":"Decrypts the encrypted data with the given public or private key. Options The accepted options are: :encoding - Optionally decode the given cipher text with either the :base64 or :hex encoding scheme. Examples BSV.Crypto.RSA.decrypt(encrypted_binary, public_or_private_key) &lt;&lt; decrypted binary &gt;&gt;"},{"ref":"BSV.Crypto.RSA.html#encrypt/3","title":"BSV.Crypto.RSA.encrypt/3","type":"function","doc":"Encrypts the given data with the given public or private key. Options The accepted options are: :encoding - Optionally encode the returned binary with either the :base64 or :hex encoding scheme. Examples BSV.Crypto.RSA.encrypt(&quot;hello world&quot;, public_or_private_key) &lt;&lt; encrypted binary &gt;&gt;"},{"ref":"BSV.Crypto.RSA.html#generate_key/1","title":"BSV.Crypto.RSA.generate_key/1","type":"function","doc":"Generates a new RSA private key. Options The accepted options are: :size - Specific the size of the RSA key. Defaults to 2048. Examples iex&gt; private_key = BSV.Crypto.RSA.generate_key ...&gt; private_key.__struct__ == BSV.Crypto.RSA.PrivateKey true"},{"ref":"BSV.Crypto.RSA.html#pem_decode/1","title":"BSV.Crypto.RSA.pem_decode/1","type":"function","doc":"Decodes the given PEM string into a public or private key. Examples iex&gt; public_key = BSV.Crypto.RSA.PrivateKey.from_sequence(BSV.Test.rsa_key) ...&gt; |&gt; BSV.Crypto.RSA.PrivateKey.get_public_key ...&gt; pem = BSV.Crypto.RSA.pem_encode(public_key) ...&gt; ...&gt; imported_key = BSV.Crypto.RSA.pem_decode(pem) ...&gt; imported_key == public_key true"},{"ref":"BSV.Crypto.RSA.html#pem_encode/1","title":"BSV.Crypto.RSA.pem_encode/1","type":"function","doc":"Encodes the given public or private key into a PEM string. Examples iex&gt; BSV.Crypto.RSA.PrivateKey.from_sequence(BSV.Test.rsa_key) ...&gt; |&gt; BSV.Crypto.RSA.PrivateKey.get_public_key ...&gt; |&gt; BSV.Crypto.RSA.pem_encode ...&gt; |&gt; String.starts_with?(&quot;-----BEGIN RSA PUBLIC KEY-----&quot;) true iex&gt; BSV.Crypto.RSA.PrivateKey.from_sequence(BSV.Test.rsa_key) ...&gt; |&gt; BSV.Crypto.RSA.pem_encode ...&gt; |&gt; String.starts_with?(&quot;-----BEGIN RSA PRIVATE KEY-----&quot;) true"},{"ref":"BSV.Crypto.RSA.html#sign/3","title":"BSV.Crypto.RSA.sign/3","type":"function","doc":"Creates a signature for the given message, using the given private key. Options The accepted options are: :encoding - Optionally encode the returned binary with either the :base64 or :hex encoding scheme. :salt_length - Specify the RSA-PSS salt length (defaults to 20). Examples BSV.Crypto.RSA.sign(&quot;hello world&quot;, private_key, encoding: :base64) &lt;&lt; signature &gt;&gt;"},{"ref":"BSV.Crypto.RSA.html#verify/4","title":"BSV.Crypto.RSA.verify/4","type":"function","doc":"Verifies the given message and signature, using the given public key. Options The accepted options are: :encoding - Optionally decode the given signature with either the :base64 or :hex encoding scheme. :salt_length - Specify the RSA-PSS salt length (defaults to 20). Examples BSV.Crypto.RSA.verify(signature, message, public_key) true"},{"ref":"BSV.Crypto.RSA.PrivateKey.html","title":"BSV.Crypto.RSA.PrivateKey","type":"module","doc":"RSA Private Key module."},{"ref":"BSV.Crypto.RSA.PrivateKey.html#as_raw/1","title":"BSV.Crypto.RSA.PrivateKey.as_raw/1","type":"function","doc":"Converts the given RSA private key struct to an Erlang private key raw list."},{"ref":"BSV.Crypto.RSA.PrivateKey.html#as_sequence/1","title":"BSV.Crypto.RSA.PrivateKey.as_sequence/1","type":"function","doc":"Converts the given RSA private key struct to an Erlang private key sequence. Examples iex&gt; private_key = BSV.Crypto.RSA.PrivateKey.from_sequence(BSV.Test.rsa_key) ...&gt; ...&gt; BSV.Crypto.RSA.PrivateKey.as_sequence(private_key) ...&gt; |&gt; is_tuple true"},{"ref":"BSV.Crypto.RSA.PrivateKey.html#from_raw/1","title":"BSV.Crypto.RSA.PrivateKey.from_raw/1","type":"function","doc":"Converts the given Erlang private key raw list to a RSA private key struct."},{"ref":"BSV.Crypto.RSA.PrivateKey.html#from_sequence/1","title":"BSV.Crypto.RSA.PrivateKey.from_sequence/1","type":"function","doc":"Converts the given Erlang private key sequence to a RSA private key struct. Examples iex&gt; private_key = BSV.Crypto.RSA.PrivateKey.from_sequence(BSV.Test.rsa_key) ...&gt; private_key.__struct__ == BSV.Crypto.RSA.PrivateKey true"},{"ref":"BSV.Crypto.RSA.PrivateKey.html#get_public_key/1","title":"BSV.Crypto.RSA.PrivateKey.get_public_key/1","type":"function","doc":"Returns the public key from the given RSA private key. Examples iex&gt; public_key = BSV.Crypto.RSA.PrivateKey.from_sequence(BSV.Test.rsa_key) ...&gt; |&gt; BSV.Crypto.RSA.PrivateKey.get_public_key ...&gt; public_key.__struct__ == BSV.Crypto.RSA.PublicKey true"},{"ref":"BSV.Crypto.RSA.PrivateKey.html#t:raw_key/0","title":"BSV.Crypto.RSA.PrivateKey.raw_key/0","type":"type","doc":"Erlang RSA Private Key raw binary list"},{"ref":"BSV.Crypto.RSA.PrivateKey.html#t:sequence/0","title":"BSV.Crypto.RSA.PrivateKey.sequence/0","type":"type","doc":"Erlang RSA Private Key sequence"},{"ref":"BSV.Crypto.RSA.PrivateKey.html#t:t/0","title":"BSV.Crypto.RSA.PrivateKey.t/0","type":"type","doc":"RSA Private Key"},{"ref":"BSV.Crypto.RSA.PublicKey.html","title":"BSV.Crypto.RSA.PublicKey","type":"module","doc":"RSA Public Key module."},{"ref":"BSV.Crypto.RSA.PublicKey.html#as_raw/1","title":"BSV.Crypto.RSA.PublicKey.as_raw/1","type":"function","doc":"Converts the given RSA private key struct to an Erlang private key raw list."},{"ref":"BSV.Crypto.RSA.PublicKey.html#as_sequence/1","title":"BSV.Crypto.RSA.PublicKey.as_sequence/1","type":"function","doc":"Converts the given RSA public key struct to an Erlang public key sequence.= Examples iex&gt; public_key = BSV.Crypto.RSA.PrivateKey.from_sequence(BSV.Test.rsa_key) ...&gt; |&gt; BSV.Crypto.RSA.PrivateKey.get_public_key ...&gt; ...&gt; BSV.Crypto.RSA.PublicKey.as_sequence(public_key) ...&gt; |&gt; is_tuple true"},{"ref":"BSV.Crypto.RSA.PublicKey.html#from_raw/1","title":"BSV.Crypto.RSA.PublicKey.from_raw/1","type":"function","doc":"Converts the given Erlang public key raw list to a RSA public key struct."},{"ref":"BSV.Crypto.RSA.PublicKey.html#from_sequence/1","title":"BSV.Crypto.RSA.PublicKey.from_sequence/1","type":"function","doc":"Converts the given Erlang public key sequence to a RSA public key struct. Examples iex&gt; public_key_sequence = BSV.Crypto.RSA.PrivateKey.from_sequence(BSV.Test.rsa_key) ...&gt; |&gt; BSV.Crypto.RSA.PrivateKey.get_public_key ...&gt; |&gt; BSV.Crypto.RSA.PublicKey.as_sequence ...&gt; ...&gt; public_key = BSV.Crypto.RSA.PublicKey.from_sequence(public_key_sequence) ...&gt; public_key.__struct__ == BSV.Crypto.RSA.PublicKey true"},{"ref":"BSV.Crypto.RSA.PublicKey.html#t:raw_key/0","title":"BSV.Crypto.RSA.PublicKey.raw_key/0","type":"type","doc":"Erlang RSA Public Key raw binary list"},{"ref":"BSV.Crypto.RSA.PublicKey.html#t:sequence/0","title":"BSV.Crypto.RSA.PublicKey.sequence/0","type":"type","doc":"Erlang RSA Public Key sequence"},{"ref":"BSV.Crypto.RSA.PublicKey.html#t:t/0","title":"BSV.Crypto.RSA.PublicKey.t/0","type":"type","doc":"RSA Public Key"}]